%define Werror_cflags	%{nil} 
%define _ssp_cflags	%{nil}
%define	cflags	%{optflags}

%define oname busybox

Summary:	Multi-call binary combining many common Unix tools into one executable
Name:		busybox-dlx
Version:	1.36.1
Release:	%mkrel 1
License:	GPLv2
Group:		Shells
URL:		http://www.busybox.net/
Source0:	http://www.busybox.net/downloads/%{oname}-%{version}.tar.xz
Source2:	busybox-1.15.2-config
Source3:	busybox-1.17.2-minimal-config
Patch0:		busybox-1.31.1-stime-fix.patch
Patch1:		busybox-i.15.2-no-march_i386.patch
Patch12:	busybox-1.2.2-ls.patch
Patch17:	busybox-1.26.2-use-Os.diff
Patch19:	busybox-1.27.2-CVE-2014-9645.patch
Patch23:	busybox-1.24.2-CVE-2016-6301.patch
# Patches from Alpine Linux for CVE-2022-28391
Patch100:       https://git.alpinelinux.org/aports/plain/main/busybox/0001-libbb-sockaddr2str-ensure-only-printable-characters-.patch
Patch101:       https://git.alpinelinux.org/aports/plain/main/busybox/0002-nslookup-sanitize-all-printed-strings-with-printable.patch

BuildRequires:	gcc
BuildRequires:	glibc-static-devel
BuildRequires:	kernel-userspace-headers

Obsoletes: busybox
Obsoletes: busybox-static

%description
BusyBox combines tiny versions of many common UNIX utilities into a
single small executable. It provides minimalist replacements for most
of the utilities you usually find in GNU coreutils, shellutils, etc.
The utilities in BusyBox generally have fewer options than their
full-featured GNU cousins; however, the options that are included provide
the expected functionality and behave very much like their GNU counterparts.
BusyBox provides a fairly complete POSIX environment for any small or
embedded system.

BusyBox has been written with size-optimization and limited resources in
mind. It is also extremely modular so you can easily include or exclude
commands (or features) at compile time. This makes it easy to customize
your embedded systems. To create a working system, just add /dev, /etc,
and a kernel.

%prep
%setup -qn %{oname}-%{version}

%patch0 -p1 -b .stime
%patch1 -b .no_march~ -p1
%patch12 -b .ls~ -p1
%patch17 -b .Os~ -p1
%patch19 -p1 -b .modprobe
%patch23 -p1 -b .ntpd-dos
%patch100 -p1
%patch101 -p1

%build
cat %{SOURCE2} |sed \
	-e 's|^.*CONFIG_EXTRA_CFLAGS.*$|CONFIG_EXTRA_CFLAGS="%{cflags} -fno-strict-aliasing"|g' \
	> .config
yes "" | %make_build oldconfig V=1
%make_build CC=%{__cc} LDFLAGS="%{ldflags}" V=1
mv busybox_unstripped busybox.full.static


%install
rm -rf %{buildroot}
install -m755 busybox.full.static -D %{buildroot}/usr/bin/busybox

%clean
rm -rf %{buildroot}

%files
%doc AUTHORS README TODO
%{_bindir}/busybox


%changelog
* Thu May 25 2023 tex - 1.36.1-1pclos2023
- new version

* Thu Jan 05 2023 tex - 1.36.0-1pclos2023
- new version

* Thu Sep 30 2021 tex - 1.34.1-1pclos2021
- new version

* Sat Aug 21 2021 tex - 1.34.0-1pclos2021
- new version

* Tue May 04 2021 tex - 1.33.1-1pclos2021
- new version

* Sun Jan 03 2021 tex - 1.32.1-1pclos2021
- rename pkg for upgrading due to stupid epoch

* Sun Jan 03 2021 tex - 1.32.1-1pclos2021
- new version

* Thu Oct 31 2019 tex - 1.31.1-1pclos2019
- new version

* Thu Feb 14 2019 tex 1.30.1-1pclos2019
- Update to version 1.30.1
